aboutsummaryrefslogtreecommitdiffstats
path: root/resources/tools/vagrant
diff options
context:
space:
mode:
Diffstat (limited to 'resources/tools/vagrant')
-rw-r--r--resources/tools/vagrant/Vagrantfile86
-rwxr-xr-xresources/tools/vagrant/install_debs.sh37
2 files changed, 123 insertions, 0 deletions
diff --git a/resources/tools/vagrant/Vagrantfile b/resources/tools/vagrant/Vagrantfile
new file mode 100644
index 0000000000..3e18192bec
--- /dev/null
+++ b/resources/tools/vagrant/Vagrantfile
@@ -0,0 +1,86 @@
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+
+# http://www.apache.org/licenses/LICENSE-2.0
+
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+
+# -*- mode: ruby -*-
+# vi: set ts=2 sw=2 sts=2 et ft=ruby :
+
+$user_addition = <<-SHELL
+ sudo deluser csit
+ sudo adduser --disabled-password --gecos "" csit
+ echo csit:csit | sudo chpasswd
+ sudo adduser csit vagrant
+ id csit
+SHELL
+
+$install_prereqs = <<-SHELL
+ sudo apt-get -y update
+ sudo apt-get -y -f install
+ sudo apt-get -y install python-virtualenv python-dev iproute2 debhelper dkms
+ sudo update-alternatives --install /bin/sh sh /bin/bash 100
+SHELL
+
+$install_vpp = <<-SHELL
+ sudo apt-get -y purge vpp\*
+ cd /vagrant
+ if [ -e /vagrant/vpp-*.deb ]; then
+ sudo dpkg -i vpp-*.deb
+ fi
+SHELL
+
+
+def add_dut(config, name, mgmt_ip, net1, net2)
+ config.vm.define name do |node|
+ node.vm.box = "puppetlabs/ubuntu-14.04-64-nocm"
+ node.vm.hostname = name
+ node.vm.provision "shell", inline: $user_addition
+ node.vm.provision "shell", inline: $install_prereqs
+ node.vm.provision "shell", inline: $install_vpp
+
+ node.vm.network "private_network", ip: mgmt_ip
+ node.vm.network "private_network", type: "dhcp", auto_config: false,
+ virtualbox__intnet: net1
+ node.vm.network "private_network", type: "dhcp", auto_config: false,
+ virtualbox__intnet: net2
+ node.vm.provider "virtualbox" do |vb|
+ vb.memory = "2048"
+ vb.customize ["modifyvm", :id, "--nicpromisc3", "allow-all"]
+ vb.customize ["modifyvm", :id, "--nicpromisc4", "allow-all"]
+ end
+ end
+
+end
+
+Vagrant.configure(2) do |config|
+ config.vm.define "tg" do |tg|
+ tg.vm.box = "puppetlabs/ubuntu-14.04-64-nocm"
+ tg.vm.hostname = "tg"
+
+ tg.vm.provision "shell", inline: $user_addition
+ tg.vm.provision "shell", inline: $install_prereqs
+ tg.vm.network "private_network", ip: '192.168.255.100/24'
+ tg.vm.network "private_network", type: "dhcp", auto_config: false,
+ virtualbox__intnet: "tg_dut1"
+ tg.vm.network "private_network", type: "dhcp", auto_config: false,
+ virtualbox__intnet: "tg_dut2"
+ tg.vm.provider "virtualbox" do |vb|
+ vb.memory = "2048"
+ vb.customize ["modifyvm", :id, "--nicpromisc3", "allow-all"]
+ vb.customize ["modifyvm", :id, "--nicpromisc4", "allow-all"]
+ end
+
+ end
+
+ add_dut(config, "dut1", "192.168.255.101/24", "tg_dut1", "dut1_dut2")
+ add_dut(config, "dut2", "192.168.255.102/24", "tg_dut2", "dut1_dut2")
+end
+
diff --git a/resources/tools/vagrant/install_debs.sh b/resources/tools/vagrant/install_debs.sh
new file mode 100755
index 0000000000..5ace4bae0d
--- /dev/null
+++ b/resources/tools/vagrant/install_debs.sh
@@ -0,0 +1,37 @@
+#!/bin/bash
+# Copyright (c) 2016 Cisco and/or its affiliates.
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at:
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+set -x
+
+USERNAME=csit
+
+function ssh_do_duts {
+ ssh ${USERNAME}@192.168.255.101 ${@} || exit
+ ssh ${USERNAME}@192.168.255.102 ${@} || exit
+}
+
+rsync -avz ${@} ${USERNAME}@192.168.255.101:/tmp/ || exit
+rsync -avz ${@} ${USERNAME}@192.168.255.102:/tmp/ || exit
+
+ssh_do_duts "sudo apt-get -y purge 'vpp.*' ; exit 0"
+ssh_do_duts "sudo dpkg -i /tmp/vpp*.deb"
+ssh_do_duts "echo 128 | sudo tee /proc/sys/vm/nr_hugepages"
+ssh_do_duts "sudo rm -f /etc/vpp/startup.conf.orig ; sudo cp /etc/vpp/startup.conf /etc/vpp/startup.conf.orig"
+ssh_do_duts "sudo rm /etc/vpp/startup.conf"
+ssh_do_duts "sudo sed -e 's/socket-mem [0-9]*/socket-mem 128/' /etc/vpp/startup.conf.orig | sudo tee /etc/vpp/startup.conf"
+ssh_do_duts "echo heapsize 512M | sudo tee -a /etc/vpp/startup.conf"
+ssh_do_duts "sudo sed -e 's/vm.nr_hugepages=.*/vm.nr_hugepages=128/' -i /etc/sysctl.d/80-vpp.conf"
+ssh_do_duts "sudo sed -e 's/vm.max_map_count=.*/vm.max_map_count=256/' -i /etc/sysctl.d/80-vpp.conf"
+
+
+echo Success!